Index: branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 530)
+++ branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 531)
@@ -345,1100 +410,1326 @@
 /* Returns a url-decoded version of str */
 /* IMPORTANT: be sure to free() the returned string after use */
-char *url_decode(char *str) {
-  char *pstr = str, *buf = (char*) malloc(strlen(str) + 1), *pbuf = buf;
-  while (*pstr) {
-    if (*pstr == '%') {
-      if (pstr[1] && pstr[2]) {
-        *pbuf++ = from_hex(pstr[1]) << 4 | from_hex(pstr[2]);
-        pstr += 2;
-      }
-    } else if (*pstr == '+') { 
-      *pbuf++ = ' ';
-    } else {
-      *pbuf++ = *pstr;
-    }
-    pstr++;
-  }
+char *
+url_decode (char *str)
+{
+  char *pstr = str, *buf = (char *) malloc (strlen (str) + 1), *pbuf = buf;
+  while (*pstr)
+    {
+      if (*pstr == '%')
+        {
+          if (pstr[1] && pstr[2])
+            {
+              *pbuf++ = from_hex (pstr[1]) << 4 | from_hex (pstr[2]);
+              pstr += 2;
+            }
+        }
+      else if (*pstr == '+')
+        {
+          *pbuf++ = ' ';
+        }
+      else
+        {
+          *pbuf++ = *pstr;
+        }
+      pstr++;
+    }
   *pbuf = '\0';
   return buf;
 }
 
-char *zCapitalize1(char *tmp){
-        char *res=strdup(tmp);
-        if(res[0]>=97 && res[0]<=122)
-                res[0]-=32;
-        return res;
-}
-
-char *zCapitalize(char *tmp){
-  int i=0;
-  char *res=strdup(tmp);
-  for(i=0;i<strlen(res);i++)
-    if(res[i]>=97 && res[i]<=122)
-      res[i]-=32;
+char *
+zCapitalize1 (char *tmp)
+{
+  char *res = strdup (tmp);
+  if (res[0] >= 97 && res[0] <= 122)
+    res[0] -= 32;
   return res;
 }
 
-
-int zooXmlSearchForNs(const char* name){
+char *
+zCapitalize (char *tmp)
+{
+  int i = 0;
+  char *res = strdup (tmp);
+  for (i = 0; i < strlen (res); i++)
+    if (res[i] >= 97 && res[i] <= 122)
+      res[i] -= 32;
+  return res;
+}
+
+
+int
+zooXmlSearchForNs (const char *name)
+{
   int i;
-  int res=-1;
-  for(i=0;i<nbNs;i++)
-    if(strncasecmp(name,nsName[i],strlen(nsName[i]))==0){
-      res=i;
-      break;
-    }
+  int res = -1;
+  for (i = 0; i < nbNs; i++)
+    if (strncasecmp (name, nsName[i], strlen (nsName[i])) == 0)
+      {
+        res = i;
+        break;
+      }
   return res;
 }
 
-int zooXmlAddNs(xmlNodePtr nr,const char* url,const char* name){
+int
+zooXmlAddNs (xmlNodePtr nr, const char *url, const char *name)
+{
 #ifdef DEBUG
-  fprintf(stderr,"zooXmlAddNs %d %s \n",nbNs,name);
-#endif
-  int currId=-1;
-  if(nbNs==0){
-    nbNs++;
-    currId=0;
-    nsName[currId]=strdup(name);
-    usedNs[currId]=xmlNewNs(nr,BAD_CAST url,BAD_CAST name);
-  }else{
-    currId=zooXmlSearchForNs(name);
-    if(currId<0){
+  fprintf (stderr, "zooXmlAddNs %d %s \n", nbNs, name);
+#endif
+  int currId = -1;
+  if (nbNs == 0)
+    {
       nbNs++;
-      currId=nbNs-1;
-      nsName[currId]=strdup(name);
-      usedNs[currId]=xmlNewNs(nr,BAD_CAST url,BAD_CAST name);
-    }
-  }
+      currId = 0;
+      nsName[currId] = strdup (name);
+      usedNs[currId] = xmlNewNs (nr, BAD_CAST url, BAD_CAST name);
+    }
+  else
+    {
+      currId = zooXmlSearchForNs (name);
+      if (currId < 0)
+        {
+          nbNs++;
+          currId = nbNs - 1;
+          nsName[currId] = strdup (name);
+          usedNs[currId] = xmlNewNs (nr, BAD_CAST url, BAD_CAST name);
+        }
+    }
   return currId;
 }
 
-void zooXmlCleanupNs(){
+void
+zooXmlCleanupNs ()
+{
   int j;
 #ifdef DEBUG
-  fprintf(stderr,"zooXmlCleanup %d\n",nbNs);
-#endif
-  for(j=nbNs-1;j>=0;j--){
+  fprintf (stderr, "zooXmlCleanup %d\n", nbNs);
+#endif
+  for (j = nbNs - 1; j >= 0; j--)
+    {
 #ifdef DEBUG
-    fprintf(stderr,"zooXmlCleanup %d\n",j);
-#endif
-    if(j==0)
-      xmlFreeNs(usedNs[j]);
-    free(nsName[j]);
-    nbNs--;
-  }
-  nbNs=0;
-}
-
-
-int zooXmlAddDoc(const char* value){
-  int currId=0;
+      fprintf (stderr, "zooXmlCleanup %d\n", j);
+#endif
+      if (j == 0)
+        xmlFreeNs (usedNs[j]);
+      free (nsName[j]);
+      nbNs--;
+    }
+  nbNs = 0;
+}
+
+
+int
+zooXmlAddDoc (const char *value)
+{
+  int currId = 0;
   nbDocs++;
-  currId=nbDocs-1;
-  iDocs[currId]=xmlParseMemory(value,strlen(value));
+  currId = nbDocs - 1;
+  iDocs[currId] = xmlParseMemory (value, strlen (value));
   return currId;
 }
 
-void zooXmlCleanupDocs(){
+void
+zooXmlCleanupDocs ()
+{
   int j;
-  for(j=nbDocs-1;j>=0;j--){
-    xmlFreeDoc(iDocs[j]);
-  }
-  nbDocs=0;
-}
-
-
-xmlNodePtr soapEnvelope(maps* conf,xmlNodePtr n){
-  map* soap=getMapFromMaps(conf,"main","isSoap");
-  if(soap!=NULL && strcasecmp(soap->value,"true")==0){
-    int lNbNs=nbNs;
-    nsName[lNbNs]=strdup("soap");
-    usedNs[lNbNs]=xmlNewNs(NULL,BAD_CAST "http://www.w3.org/2003/05/soap-envelope",BAD_CAST "soap");
-    nbNs++;
-    xmlNodePtr nr = xmlNewNode(usedNs[lNbNs], BAD_CAST "Envelope");
-    nsName[nbNs]=strdup("soap");
-    usedNs[nbNs]=xmlNewNs(nr,BAD_CAST "http://www.w3.org/2003/05/soap-envelope",BAD_CAST "soap");
-    nbNs++;
-    nsName[nbNs]=strdup("xsi");
-    usedNs[nbNs]=xmlNewNs(nr,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
-    nbNs++;
-    xmlNsPtr ns_xsi=usedNs[nbNs-1];
-    xmlNewNsProp(nr,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.w3.org/2003/05/soap-envelope http://www.w3.org/2003/05/soap-envelope");
-    xmlNodePtr nr1 = xmlNewNode(usedNs[lNbNs], BAD_CAST "Body");
-    xmlAddChild(nr1,n);
-    xmlAddChild(nr,nr1);
-    return nr;
-  }else
+  for (j = nbDocs - 1; j >= 0; j--)
+    {
+      xmlFreeDoc (iDocs[j]);
+    }
+  nbDocs = 0;
+}
+
+
+xmlNodePtr
+soapEnvelope (maps * conf, xmlNodePtr n)
+{
+  map *soap = getMapFromMaps (conf, "main", "isSoap");
+  if (soap != NULL && strcasecmp (soap->value, "true") == 0)
+    {
+      int lNbNs = nbNs;
+      nsName[lNbNs] = strdup ("soap");
+      usedNs[lNbNs] =
+        xmlNewNs (NULL, BAD_CAST "http://www.w3.org/2003/05/soap-envelope",
+                  BAD_CAST "soap");
+      nbNs++;
+      xmlNodePtr nr = xmlNewNode (usedNs[lNbNs], BAD_CAST "Envelope");
+      nsName[nbNs] = strdup ("soap");
+      usedNs[nbNs] =
+        xmlNewNs (nr, BAD_CAST "http://www.w3.org/2003/05/soap-envelope",
+                  BAD_CAST "soap");
+      nbNs++;
+      nsName[nbNs] = strdup ("xsi");
+      usedNs[nbNs] =
+        xmlNewNs (nr, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",
+                  BAD_CAST "xsi");
+      nbNs++;
+      xmlNsPtr ns_xsi = usedNs[nbNs - 1];
+      xmlNewNsProp (nr, ns_xsi, BAD_CAST "schemaLocation",
+                    BAD_CAST
+                    "http://www.w3.org/2003/05/soap-envelope http://www.w3.org/2003/05/soap-envelope");
+      xmlNodePtr nr1 = xmlNewNode (usedNs[lNbNs], BAD_CAST "Body");
+      xmlAddChild (nr1, n);
+      xmlAddChild (nr, nr1);
+      return nr;
+    }
+  else
     return n;
 }
 
-xmlNodePtr printGetCapabilitiesHeader(xmlDocPtr doc,const char* service,maps* m){
-
-  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  xmlNodePtr n,nc,nc1,nc2,nc3,nc4,nc5,nc6;
+xmlNodePtr
+printGetCapabilitiesHeader (xmlDocPtr doc, const char *service, maps * m)
+{
+
+  xmlNsPtr ns, ns_ows, ns_xlink, ns_xsi;
+  xmlNodePtr n, nc, nc1, nc2, nc3, nc4, nc5, nc6;
   /**
    * Create the document and its temporary root.
    */
-  int wpsId=zooXmlAddNs(NULL,"http://www.opengis.net/wps/1.0.0","wps");
-  ns=usedNs[wpsId];
-  maps* toto1=getMaps(m,"main");
-
-  n = xmlNewNode(ns, BAD_CAST "Capabilities");
-  int owsId=zooXmlAddNs(n,"http://www.opengis.net/ows/1.1","ows");
-  ns_ows=usedNs[owsId];
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  int xsiId=zooXmlAddNs(n,"http://www.w3.org/2001/XMLSchema-instance","xsi");
-  ns_xsi=usedNs[xsiId];
-  int xlinkId=zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
-  ns_xlink=usedNs[xlinkId];
-  xmlNewNsProp(n,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsGetCapabilities_response.xsd"); 
-  xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
-  addLangAttr(n,m);
-  
-  if(toto1!=NULL){
-    map* tmp=getMap(toto1->content,"version");
-    if(tmp!=NULL){
-      xmlNewProp(n,BAD_CAST "version",BAD_CAST tmp->value);
-    }
-    else
-      xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-  }
+  int wpsId = zooXmlAddNs (NULL, "http://www.opengis.net/wps/1.0.0", "wps");
+  ns = usedNs[wpsId];
+  maps *toto1 = getMaps (m, "main");
+
+  n = xmlNewNode (ns, BAD_CAST "Capabilities");
+  int owsId = zooXmlAddNs (n, "http://www.opengis.net/ows/1.1", "ows");
+  ns_ows = usedNs[owsId];
+  xmlNewNs (n, BAD_CAST "http://www.opengis.net/wps/1.0.0", BAD_CAST "wps");
+  int xsiId =
+    zooXmlAddNs (n, "http://www.w3.org/2001/XMLSchema-instance", "xsi");
+  ns_xsi = usedNs[xsiId];
+  int xlinkId = zooXmlAddNs (n, "http://www.w3.org/1999/xlink", "xlink");
+  ns_xlink = usedNs[xlinkId];
+  xmlNewNsProp (n, ns_xsi, BAD_CAST "schemaLocation",
+                BAD_CAST
+                "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsGetCapabilities_response.xsd");
+  xmlNewProp (n, BAD_CAST "service", BAD_CAST "WPS");
+  addLangAttr (n, m);
+
+  if (toto1 != NULL)
+    {
+      map *tmp = getMap (toto1->content, "version");
+      if (tmp != NULL)
+        {
+          xmlNewProp (n, BAD_CAST "version", BAD_CAST tmp->value);
+        }
+      else
+        xmlNewProp (n, BAD_CAST "version", BAD_CAST "1.0.0");
+    }
   else
-    xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
+    xmlNewProp (n, BAD_CAST "version", BAD_CAST "1.0.0");
 
   char tmp[256];
-  
-  nc = xmlNewNode(ns_ows, BAD_CAST "ServiceIdentification");
-  maps* tmp4=getMaps(m,"identification");
-  if(tmp4!=NULL){
-    map* tmp2=tmp4->content;
-    const char *orderedFields[5];
-    orderedFields[0]="Title";
-    orderedFields[1]="Abstract";
-    orderedFields[2]="Keywords";
-    orderedFields[3]="Fees";
-    orderedFields[4]="AccessConstraints";
-    int oI=0;
-    for(oI=0;oI<5;oI++)
-      if((tmp2=getMap(tmp4->content,orderedFields[oI]))!=NULL){
-	if(strcasecmp(tmp2->name,"abstract")==0 ||
-	   strcasecmp(tmp2->name,"title")==0 ||
-	   strcasecmp(tmp2->name,"accessConstraints")==0 ||
-	   strcasecmp(tmp2->name,"fees")==0){
-	  tmp2->name[0]=toupper(tmp2->name[0]);
-	  nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
-	  xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-	  xmlAddChild(nc,nc1);
-	}
-	else
-	  if(strcmp(tmp2->name,"keywords")==0){
-	    nc1 = xmlNewNode(ns_ows, BAD_CAST "Keywords");
-	    char *toto=tmp2->value;
-	    char buff[256];
-	    int i=0;
-	    int j=0;
-	    while(toto[i]){
-	      if(toto[i]!=',' && toto[i]!=0){
-		buff[j]=toto[i];
-		buff[j+1]=0;
-		j++;
-	      }
-	      else{
-		nc2 = xmlNewNode(ns_ows, BAD_CAST "Keyword");
-		xmlAddChild(nc2,xmlNewText(BAD_CAST buff));	      
-		xmlAddChild(nc1,nc2);
-		j=0;
-	      }
-	      i++;
-	    }
-	    if(strlen(buff)>0){
-	      nc2 = xmlNewNode(ns_ows, BAD_CAST "Keyword");
-	      xmlAddChild(nc2,xmlNewText(BAD_CAST buff));	      
-	      xmlAddChild(nc1,nc2);
-	    }
-	    xmlAddChild(nc,nc1);
-	    nc2 = xmlNewNode(ns_ows, BAD_CAST "ServiceType");
-	    xmlAddChild(nc2,xmlNewText(BAD_CAST "WPS"));
-	    xmlAddChild(nc,nc2);
-	    nc2 = xmlNewNode(ns_ows, BAD_CAST "ServiceTypeVersion");
-	    xmlAddChild(nc2,xmlNewText(BAD_CAST "1.0.0"));
-	    xmlAddChild(nc,nc2);	  
-	  }
-	tmp2=tmp2->next;
-      }
-  }
-  else{
-    fprintf(stderr,"TMP4 NOT FOUND !!");
-    return NULL;
-  }
-  xmlAddChild(n,nc);
-
-  nc = xmlNewNode(ns_ows, BAD_CAST "ServiceProvider");
-  nc3 = xmlNewNode(ns_ows, BAD_CAST "ServiceContact");
-  nc4 = xmlNewNode(ns_ows, BAD_CAST "ContactInfo");
-  nc5 = xmlNewNode(ns_ows, BAD_CAST "Phone");
-  nc6 = xmlNewNode(ns_ows, BAD_CAST "Address");
-  tmp4=getMaps(m,"provider");
-  if(tmp4!=NULL){
-    map* tmp2=tmp4->content;
-    const char *tmpAddress[6];
-    tmpAddress[0]="addressDeliveryPoint";
-    tmpAddress[1]="addressCity";
-    tmpAddress[2]="addressAdministrativeArea";
-    tmpAddress[3]="addressPostalCode";
-    tmpAddress[4]="addressCountry";
-    tmpAddress[5]="addressElectronicMailAddress";
-    const char *tmpPhone[2];
-    tmpPhone[0]="phoneVoice";
-    tmpPhone[1]="phoneFacsimile";
-    const char *orderedFields[12];
-    orderedFields[0]="providerName";
-    orderedFields[1]="providerSite";
-    orderedFields[2]="individualName";
-    orderedFields[3]="positionName";
-    orderedFields[4]=tmpPhone[0];
-    orderedFields[5]=tmpPhone[1];
-    orderedFields[6]=tmpAddress[0];
-    orderedFields[7]=tmpAddress[1];
-    orderedFields[8]=tmpAddress[2];
-    orderedFields[9]=tmpAddress[3];
-    orderedFields[10]=tmpAddress[4];
-    orderedFields[11]=tmpAddress[5];
-    int oI=0;
-    for(oI=0;oI<12;oI++)
-      if((tmp2=getMap(tmp4->content,orderedFields[oI]))!=NULL){
-	if(strcmp(tmp2->name,"keywords")!=0 &&
-	   strcmp(tmp2->name,"serverAddress")!=0 &&
-	   strcmp(tmp2->name,"lang")!=0){
-	  tmp2->name[0]=toupper(tmp2->name[0]);
-	  if(strcmp(tmp2->name,"ProviderName")==0){
-	    nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
-	    xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-	    xmlAddChild(nc,nc1);
-	  }
-	  else{
-	    if(strcmp(tmp2->name,"ProviderSite")==0){
-	      nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
-	      xmlNewNsProp(nc1,ns_xlink,BAD_CAST "href",BAD_CAST tmp2->value);
-	      xmlAddChild(nc,nc1);
-	    } 
-	    else  
-	      if(strcmp(tmp2->name,"IndividualName")==0 || 
-		 strcmp(tmp2->name,"PositionName")==0){
-		nc1 = xmlNewNode(ns_ows, BAD_CAST tmp2->name);
-		xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-		xmlAddChild(nc3,nc1);
-	      } 
-	      else 
-		if(strncmp(tmp2->name,"Phone",5)==0){
-		  int j;
-		  for(j=0;j<2;j++)
-		    if(strcasecmp(tmp2->name,tmpPhone[j])==0){
-		      char *tmp4=tmp2->name;
-		      nc1 = xmlNewNode(ns_ows, BAD_CAST tmp4+5);
-		      xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-		      xmlAddChild(nc5,nc1);
-		    }
-		}
-		else 
-		  if(strncmp(tmp2->name,"Address",7)==0){
-		    int j;
-		    for(j=0;j<6;j++)
-		      if(strcasecmp(tmp2->name,tmpAddress[j])==0){
-			char *tmp4=tmp2->name;
-			nc1 = xmlNewNode(ns_ows, BAD_CAST tmp4+7);
-			xmlAddChild(nc1,xmlNewText(BAD_CAST tmp2->value));
-			xmlAddChild(nc6,nc1);
-		      }
-		  }
-	  }
-	}
-	else
-	  if(strcmp(tmp2->name,"keywords")==0){
-	    nc1 = xmlNewNode(ns_ows, BAD_CAST "Keywords");
-	    char *toto=tmp2->value;
-	    char buff[256];
-	    int i=0;
-	    int j=0;
-	    while(toto[i]){
-	      if(toto[i]!=',' && toto[i]!=0){
-		buff[j]=toto[i];
-		buff[j+1]=0;
-		j++;
-	      }
-	      else{
-		nc2 = xmlNewNode(ns_ows, BAD_CAST "Keyword");
-		xmlAddChild(nc2,xmlNewText(BAD_CAST buff));	      
-		xmlAddChild(nc1,nc2);
-		j=0;
-	      }
-	      i++;
-	    }
-	    if(strlen(buff)>0){
-	      nc2 = xmlNewNode(ns_ows, BAD_CAST "Keyword");
-	      xmlAddChild(nc2,xmlNewText(BAD_CAST buff));	      
-	      xmlAddChild(nc1,nc2);
-	    }
-	    xmlAddChild(nc,nc1);
-	  }
-	tmp2=tmp2->next;
-      }
-  }
-  else{
-    fprintf(stderr,"TMP4 NOT FOUND !!");
-  }
-  xmlAddChild(nc4,nc5);
-  xmlAddChild(nc4,nc6);
-  xmlAddChild(nc3,nc4);
-  xmlAddChild(nc,nc3);
-  xmlAddChild(n,nc);
-
-
-  nc = xmlNewNode(ns_ows, BAD_CAST "OperationsMetadata");
+
+  nc = xmlNewNode (ns_ows, BAD_CAST "ServiceIdentification");
+  maps *tmp4 = getMaps (m, "identification");
+  if (tmp4 != NULL)
+    {
+      map *tmp2 = tmp4->content;
+      const char *orderedFields[5];
+      orderedFields[0] = "Title";
+      orderedFields[1] = "Abstract";
+      orderedFields[2] = "Keywords";
+      orderedFields[3] = "Fees";
+      orderedFields[4] = "AccessConstraints";
+      int oI = 0;
+      for (oI = 0; oI < 5; oI++)
+        if ((tmp2 = getMap (tmp4->content, orderedFields[oI])) != NULL)
+          {
+            if (strcasecmp (tmp2->name, "abstract") == 0 ||
+                strcasecmp (tmp2->name, "title") == 0 ||
+                strcasecmp (tmp2->name, "accessConstraints") == 0 ||
+                strcasecmp (tmp2->name, "fees") == 0)
+              {
+                tmp2->name[0] = toupper (tmp2->name[0]);
+                nc1 = xmlNewNode (ns_ows, BAD_CAST tmp2->name);
+                xmlAddChild (nc1, xmlNewText (BAD_CAST tmp2->value));
+                xmlAddChild (nc, nc1);
+              }
+            else if (strcmp (tmp2->name, "keywords") == 0)
+              {
+                nc1 = xmlNewNode (ns_ows, BAD_CAST "Keywords");
+                char *toto = tmp2->value;
+                char buff[256];
+                int i = 0;
+                int j = 0;
+                while (toto[i])
+                  {
+                    if (toto[i] != ',' && toto[i] != 0)
+                      {
+                        buff[j] = toto[i];
+                        buff[j + 1] = 0;
+                        j++;
+                      }
+                    else
+                      {
+                        nc2 = xmlNewNode (ns_ows, BAD_CAST "Keyword");
+                        xmlAddChild (nc2, xmlNewText (BAD_CAST buff));
+                        xmlAddChild (nc1, nc2);
+                        j = 0;
+                      }
+                    i++;
+                  }
+                if (strlen (buff) > 0)
+                  {
+                    nc2 = xmlNewNode (ns_ows, BAD_CAST "Keyword");
+                    xmlAddChild (nc2, xmlNewText (BAD_CAST buff));
+                    xmlAddChild (nc1, nc2);
+                  }
+                xmlAddChild (nc, nc1);
+                nc2 = xmlNewNode (ns_ows, BAD_CAST "ServiceType");
+                xmlAddChild (nc2, xmlNewText (BAD_CAST "WPS"));
+                xmlAddChild (nc, nc2);
+                nc2 = xmlNewNode (ns_ows, BAD_CAST "ServiceTypeVersion");
+                xmlAddChild (nc2, xmlNewText (BAD_CAST "1.0.0"));
+                xmlAddChild (nc, nc2);
+              }
+            tmp2 = tmp2->next;
+          }
+    }
+  else
+    {
+      fprintf (stderr, "TMP4 NOT FOUND !!");
+      return NULL;
+    }
+  xmlAddChild (n, nc);
+
+  nc = xmlNewNode (ns_ows, BAD_CAST "ServiceProvider");
+  nc3 = xmlNewNode (ns_ows, BAD_CAST "ServiceContact");
+  nc4 = xmlNewNode (ns_ows, BAD_CAST "ContactInfo");
+  nc5 = xmlNewNode (ns_ows, BAD_CAST "Phone");
+  nc6 = xmlNewNode (ns_ows, BAD_CAST "Address");
+  tmp4 = getMaps (m, "provider");
+  if (tmp4 != NULL)
+    {
+      map *tmp2 = tmp4->content;
+      const char *tmpAddress[6];
+      tmpAddress[0] = "addressDeliveryPoint";
+      tmpAddress[1] = "addressCity";
+      tmpAddress[2] = "addressAdministrativeArea";
+      tmpAddress[3] = "addressPostalCode";
+      tmpAddress[4] = "addressCountry";
+      tmpAddress[5] = "addressElectronicMailAddress";
+      const char *tmpPhone[2];
+      tmpPhone[0] = "phoneVoice";
+      tmpPhone[1] = "phoneFacsimile";
+      const char *orderedFields[12];
+      orderedFields[0] = "providerName";
+      orderedFields[1] = "providerSite";
+      orderedFields[2] = "individualName";
+      orderedFields[3] = "positionName";
+      orderedFields[4] = tmpPhone[0];
+      orderedFields[5] = tmpPhone[1];
+      orderedFields[6] = tmpAddress[0];
+      orderedFields[7] = tmpAddress[1];
+      orderedFields[8] = tmpAddress[2];
+      orderedFields[9] = tmpAddress[3];
+      orderedFields[10] = tmpAddress[4];
+      orderedFields[11] = tmpAddress[5];
+      int oI = 0;
+      for (oI = 0; oI < 12; oI++)
+        if ((tmp2 = getMap (tmp4->content, orderedFields[oI])) != NULL)
+          {
+            if (strcmp (tmp2->name, "keywords") != 0 &&
+                strcmp (tmp2->name, "serverAddress") != 0 &&
+                strcmp (tmp2->name, "lang") != 0)
+              {
+                tmp2->name[0] = toupper (tmp2->name[0]);
+                if (strcmp (tmp2->name, "ProviderName") == 0)
+                  {
+                    nc1 = xmlNewNode (ns_ows, BAD_CAST tmp2->name);
+                    xmlAddChild (nc1, xmlNewText (BAD_CAST tmp2->value));
+                    xmlAddChild (nc, nc1);
+                  }
+                else
+                  {
+                    if (strcmp (tmp2->name, "ProviderSite") == 0)
+                      {
+                        nc1 = xmlNewNode (ns_ows, BAD_CAST tmp2->name);
+                        xmlNewNsProp (nc1, ns_xlink, BAD_CAST "href",
+                                      BAD_CAST tmp2->value);
+                        xmlAddChild (nc, nc1);
+                      }
+                    else
+                      if (strcmp (tmp2->name, "IndividualName") == 0 ||
+                          strcmp (tmp2->name, "PositionName") == 0)
+                      {
+                        nc1 = xmlNewNode (ns_ows, BAD_CAST tmp2->name);
+                        xmlAddChild (nc1, xmlNewText (BAD_CAST tmp2->value));
+                        xmlAddChild (nc3, nc1);
+                      }
+                    else if (strncmp (tmp2->name, "Phone", 5) == 0)
+                      {
+                        int j;
+                        for (j = 0; j < 2; j++)
+                          if (strcasecmp (tmp2->name, tmpPhone[j]) == 0)
+                            {
+                              char *tmp4 = tmp2->name;
+                              nc1 = xmlNewNode (ns_ows, BAD_CAST tmp4 + 5);
+                              xmlAddChild (nc1,
+                                           xmlNewText (BAD_CAST tmp2->value));
+                              xmlAddChild (nc5, nc1);
+                            }
+                      }
+                    else if (strncmp (tmp2->name, "Address", 7) == 0)
+                      {
+                        int j;
+                        for (j = 0; j < 6; j++)
+                          if (strcasecmp (tmp2->name, tmpAddress[j]) == 0)
+                            {
+                              char *tmp4 = tmp2->name;
+                              nc1 = xmlNewNode (ns_ows, BAD_CAST tmp4 + 7);
+                              xmlAddChild (nc1,
+                                           xmlNewText (BAD_CAST tmp2->value));
+                              xmlAddChild (nc6, nc1);
+                            }
+                      }
+                  }
+              }
+            else if (strcmp (tmp2->name, "keywords") == 0)
+              {
+                nc1 = xmlNewNode (ns_ows, BAD_CAST "Keywords");
+                char *toto = tmp2->value;
+                char buff[256];
+                int i = 0;
+                int j = 0;
+                while (toto[i])
+                  {
+                    if (toto[i] != ',' && toto[i] != 0)
+                      {
+                        buff[j] = toto[i];
+                        buff[j + 1] = 0;
+                        j++;
+                      }
+                    else
+                      {
+                        nc2 = xmlNewNode (ns_ows, BAD_CAST "Keyword");
+                        xmlAddChild (nc2, xmlNewText (BAD_CAST buff));
+                        xmlAddChild (nc1, nc2);
+                        j = 0;
+                      }
+                    i++;
+                  }
+                if (strlen (buff) > 0)
+                  {
+                    nc2 = xmlNewNode (ns_ows, BAD_CAST "Keyword");
+                    xmlAddChild (nc2, xmlNewText (BAD_CAST buff));
+                    xmlAddChild (nc1, nc2);
+                  }
+                xmlAddChild (nc, nc1);
+              }
+            tmp2 = tmp2->next;
+          }
+    }
+  else
+    {
+      fprintf (stderr, "TMP4 NOT FOUND !!");
+    }
+  xmlAddChild (nc4, nc5);
+  xmlAddChild (nc4, nc6);
+  xmlAddChild (nc3, nc4);
+  xmlAddChild (nc, nc3);
+  xmlAddChild (n, nc);
+
+
+  nc = xmlNewNode (ns_ows, BAD_CAST "OperationsMetadata");
   char *tmp2[3];
-  tmp2[0]=strdup("GetCapabilities");
-  tmp2[1]=strdup("DescribeProcess");
-  tmp2[2]=strdup("Execute");
-  int j=0;
-
-  if(toto1!=NULL){
-    map* tmp=getMap(toto1->content,"serverAddress");
-    if(tmp!=NULL){
-      SERVICE_URL = strdup(tmp->value);
-    }
-    else
-      SERVICE_URL = strdup("not_found");
-  }
+  tmp2[0] = strdup ("GetCapabilities");
+  tmp2[1] = strdup ("DescribeProcess");
+  tmp2[2] = strdup ("Execute");
+  int j = 0;
+
+  if (toto1 != NULL)
+    {
+      map *tmp = getMap (toto1->content, "serverAddress");
+      if (tmp != NULL)
+        {
+          SERVICE_URL = strdup (tmp->value);
+        }
+      else
+        SERVICE_URL = strdup ("not_found");
+    }
   else
-    SERVICE_URL = strdup("not_found");
-
-  for(j=0;j<3;j++){
-    nc1 = xmlNewNode(ns_ows, BAD_CAST "Operation");
-    xmlNewProp(nc1,BAD_CAST "name",BAD_CAST tmp2[j]);
-    nc2 = xmlNewNode(ns_ows, BAD_CAST "DCP");
-    nc3 = xmlNewNode(ns_ows, BAD_CAST "HTTP");
-    nc4 = xmlNewNode(ns_ows, BAD_CAST "Get");
-    sprintf(tmp,"%s/%s",SERVICE_URL,service);
-    xmlNewNsProp(nc4,ns_xlink,BAD_CAST "href",BAD_CAST tmp);
-    xmlAddChild(nc3,nc4);
-    if(j>0){
-      nc4 = xmlNewNode(ns_ows, BAD_CAST "Post");
-      xmlNewNsProp(nc4,ns_xlink,BAD_CAST "href",BAD_CAST tmp);
-      xmlAddChild(nc3,nc4);
-    }
-    xmlAddChild(nc2,nc3);
-    xmlAddChild(nc1,nc2);    
-    xmlAddChild(nc,nc1);    
-  }
-  for(j=2;j>=0;j--)
-    free(tmp2[j]);
-  xmlAddChild(n,nc);
-
-  nc = xmlNewNode(ns, BAD_CAST "ProcessOfferings");
-  xmlAddChild(n,nc);
-
-  nc1 = xmlNewNode(ns, BAD_CAST "Languages");
-  nc2 = xmlNewNode(ns, BAD_CAST "Default");
-  nc3 = xmlNewNode(ns, BAD_CAST "Supported");
-  
-  toto1=getMaps(m,"main");
-  if(toto1!=NULL){
-    map* tmp1=getMap(toto1->content,"lang");
-    char *toto=tmp1->value;
-    char buff[256];
-    int i=0;
-    int j=0;
-    int dcount=0;
-    while(toto[i]){
-      if(toto[i]!=',' && toto[i]!=0){
-	buff[j]=toto[i];
-	buff[j+1]=0;
-	j++;
-      }
-      else{
-	nc4 = xmlNewNode(ns_ows, BAD_CAST "Language");
-	xmlAddChild(nc4,xmlNewText(BAD_CAST buff));
-	if(dcount==0){
-	  xmlAddChild(nc2,nc4);
-	  xmlAddChild(nc1,nc2);
-	  dcount++;
-	}
-	nc4 = xmlNewNode(ns_ows, BAD_CAST "Language");
-	xmlAddChild(nc4,xmlNewText(BAD_CAST buff));
-	xmlAddChild(nc3,nc4);
-	j=0;
-	buff[j]=0;
-      }
-      i++;
-    }
-    if(strlen(buff)>0){
-      nc4 = xmlNewNode(ns_ows, BAD_CAST "Language");
-      xmlAddChild(nc4,xmlNewText(BAD_CAST buff));	      
-      xmlAddChild(nc3,nc4);
-    }
-  }
-  xmlAddChild(nc1,nc3);
-  xmlAddChild(n,nc1);
-  
-  xmlNodePtr fn=soapEnvelope(m,n);
-  xmlDocSetRootElement(doc, fn);
+    SERVICE_URL = strdup ("not_found");
+
+  for (j = 0; j < 3; j++)
+    {
+      nc1 = xmlNewNode (ns_ows, BAD_CAST "Operation");
+      xmlNewProp (nc1, BAD_CAST "name", BAD_CAST tmp2[j]);
+      nc2 = xmlNewNode (ns_ows, BAD_CAST "DCP");
+      nc3 = xmlNewNode (ns_ows, BAD_CAST "HTTP");
+      nc4 = xmlNewNode (ns_ows, BAD_CAST "Get");
+      sprintf (tmp, "%s/%s", SERVICE_URL, service);
+      xmlNewNsProp (nc4, ns_xlink, BAD_CAST "href", BAD_CAST tmp);
+      xmlAddChild (nc3, nc4);
+      if (j > 0)
+        {
+          nc4 = xmlNewNode (ns_ows, BAD_CAST "Post");
+          xmlNewNsProp (nc4, ns_xlink, BAD_CAST "href", BAD_CAST tmp);
+          xmlAddChild (nc3, nc4);
+        }
+      xmlAddChild (nc2, nc3);
+      xmlAddChild (nc1, nc2);
+      xmlAddChild (nc, nc1);
+    }
+  for (j = 2; j >= 0; j--)
+    free (tmp2[j]);
+  xmlAddChild (n, nc);
+
+  nc = xmlNewNode (ns, BAD_CAST "ProcessOfferings");
+  xmlAddChild (n, nc);
+
+  nc1 = xmlNewNode (ns, BAD_CAST "Languages");
+  nc2 = xmlNewNode (ns, BAD_CAST "Default");
+  nc3 = xmlNewNode (ns, BAD_CAST "Supported");
+
+  toto1 = getMaps (m, "main");
+  if (toto1 != NULL)
+    {
+      map *tmp1 = getMap (toto1->content, "lang");
+      char *toto = tmp1->value;
+      char buff[256];
+      int i = 0;
+      int j = 0;
+      int dcount = 0;
+      while (toto[i])
+        {
+          if (toto[i] != ',' && toto[i] != 0)
+            {
+              buff[j] = toto[i];
+              buff[j + 1] = 0;
+              j++;
+            }
+          else
+            {
+              nc4 = xmlNewNode (ns_ows, BAD_CAST "Language");
+              xmlAddChild (nc4, xmlNewText (BAD_CAST buff));
+              if (dcount == 0)
+                {
+                  xmlAddChild (nc2, nc4);
+                  xmlAddChild (nc1, nc2);
+                  dcount++;
+                }
+              nc4 = xmlNewNode (ns_ows, BAD_CAST "Language");
+              xmlAddChild (nc4, xmlNewText (BAD_CAST buff));
+              xmlAddChild (nc3, nc4);
+              j = 0;
+              buff[j] = 0;
+            }
+          i++;
+        }
+      if (strlen (buff) > 0)
+        {
+          nc4 = xmlNewNode (ns_ows, BAD_CAST "Language");
+          xmlAddChild (nc4, xmlNewText (BAD_CAST buff));
+          xmlAddChild (nc3, nc4);
+        }
+    }
+  xmlAddChild (nc1, nc3);
+  xmlAddChild (n, nc1);
+
+  xmlNodePtr fn = soapEnvelope (m, n);
+  xmlDocSetRootElement (doc, fn);
   //xmlFreeNs(ns);
-  free(SERVICE_URL);
+  free (SERVICE_URL);
   return nc;
 }
 
-void addPrefix(maps* conf,map* level,service* serv){
-  if(level!=NULL){
-    char key[25];
-    char* prefix=NULL;
-    int clevel=atoi(level->value);
-    int cl=0;
-    for(cl=0;cl<clevel;cl++){
-      sprintf(key,"sprefix_%d",cl);
-      map* tmp2=getMapFromMaps(conf,"lenv",key);
-      if(tmp2!=NULL){
-	if(prefix==NULL)
-	  prefix=zStrdup(tmp2->value);
-	else{
-	  int plen=strlen(prefix);
-	  prefix=(char*)realloc(prefix,(plen+strlen(tmp2->value)+2)*sizeof(char));
-	  memcpy(prefix+plen,tmp2->value,strlen(tmp2->value)*sizeof(char));
-	  prefix[plen+strlen(tmp2->value)]=0;
-	}
-      }
-    }
-    if(prefix!=NULL){
-      char* tmp0=strdup(serv->name);
-      free(serv->name);
-      serv->name=(char*)malloc((strlen(prefix)+strlen(tmp0)+1)*sizeof(char));
-      sprintf(serv->name,"%s%s",prefix,tmp0);
-      free(tmp0);
-      free(prefix);
-      prefix=NULL;
-    }
-  }
-}
-
-void printGetCapabilitiesForProcess(maps* m,xmlNodePtr nc,service* serv){
-  xmlNsPtr ns,ns_ows,ns_xlink;
-  xmlNodePtr n=NULL,nc1,nc2;
+void
+addPrefix (maps * conf, map * level, service * serv)
+{
+  if (level != NULL)
+    {
+      char key[25];
+      char *prefix = NULL;
+      int clevel = atoi (level->value);
+      int cl = 0;
+      for (cl = 0; cl < clevel; cl++)
+        {
+          sprintf (key, "sprefix_%d", cl);
+          map *tmp2 = getMapFromMaps (conf, "lenv", key);
+          if (tmp2 != NULL)
+            {
+              if (prefix == NULL)
+                prefix = zStrdup (tmp2->value);
+              else
+                {
+                  int plen = strlen (prefix);
+                  prefix =
+                    (char *) realloc (prefix,
+                                      (plen + strlen (tmp2->value) +
+                                       2) * sizeof (char));
+                  memcpy (prefix + plen, tmp2->value,
+                          strlen (tmp2->value) * sizeof (char));
+                  prefix[plen + strlen (tmp2->value)] = 0;
+                }
+            }
+        }
+      if (prefix != NULL)
+        {
+          char *tmp0 = strdup (serv->name);
+          free (serv->name);
+          serv->name =
+            (char *) malloc ((strlen (prefix) + strlen (tmp0) + 1) *
+                             sizeof (char));
+          sprintf (serv->name, "%s%s", prefix, tmp0);
+          free (tmp0);
+          free (prefix);
+          prefix = NULL;
+        }
+    }
+}
+
+void
+printGetCapabilitiesForProcess (maps * m, xmlNodePtr nc, service * serv)
+{
+  xmlNsPtr ns, ns_ows, ns_xlink;
+  xmlNodePtr n = NULL, nc1, nc2;
   /**
    * Initialize or get existing namspaces
    */
-  int wpsId=zooXmlAddNs(NULL,"http://www.opengis.net/wps/1.0.0","wps");
-  ns=usedNs[wpsId];
-  int owsId=zooXmlAddNs(NULL,"http://www.opengis.net/ows/1.1","ows");
-  ns_ows=usedNs[owsId];
-  int xlinkId=zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
-  ns_xlink=usedNs[xlinkId];
-
-  map* tmp1;
-  if(serv->content!=NULL){
-    nc1 = xmlNewNode(ns, BAD_CAST "Process");
-    tmp1=getMap(serv->content,"processVersion");
-    if(tmp1!=NULL)
-      xmlNewNsProp(nc1,ns,BAD_CAST "processVersion",BAD_CAST tmp1->value);
-    map* tmp3=getMapFromMaps(m,"lenv","level");
-    addPrefix(m,tmp3,serv);
-    printDescription(nc1,ns_ows,serv->name,serv->content);
-    tmp1=serv->metadata;
-    while(tmp1!=NULL){
-      nc2 = xmlNewNode(ns_ows, BAD_CAST "Metadata");
-      xmlNewNsProp(nc2,ns_xlink,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-      xmlAddChild(nc1,nc2);
-      tmp1=tmp1->next;
-    }
-    xmlAddChild(nc,nc1);
-  }
-}
-
-xmlNodePtr printDescribeProcessHeader(xmlDocPtr doc,const char* service,maps* m){
-
-  xmlNsPtr ns,ns_xsi;
+  int wpsId = zooXmlAddNs (NULL, "http://www.opengis.net/wps/1.0.0", "wps");
+  ns = usedNs[wpsId];
+  int owsId = zooXmlAddNs (NULL, "http://www.opengis.net/ows/1.1", "ows");
+  ns_ows = usedNs[owsId];
+  int xlinkId = zooXmlAddNs (n, "http://www.w3.org/1999/xlink", "xlink");
+  ns_xlink = usedNs[xlinkId];
+
+  map *tmp1;
+  if (serv->content != NULL)
+    {
+      nc1 = xmlNewNode (ns, BAD_CAST "Process");
+      tmp1 = getMap (serv->content, "processVersion");
+      if (tmp1 != NULL)
+        xmlNewNsProp (nc1, ns, BAD_CAST "processVersion",
+                      BAD_CAST tmp1->value);
+      map *tmp3 = getMapFromMaps (m, "lenv", "level");
+      addPrefix (m, tmp3, serv);
+      printDescription (nc1, ns_ows, serv->name, serv->content);
+      tmp1 = serv->metadata;
+      while (tmp1 != NULL)
+        {
+          nc2 = xmlNewNode (ns_ows, BAD_CAST "Metadata");
+          xmlNewNsProp (nc2, ns_xlink, BAD_CAST tmp1->name,
+                        BAD_CAST tmp1->value);
+          xmlAddChild (nc1, nc2);
+          tmp1 = tmp1->next;
+        }
+      xmlAddChild (nc, nc1);
+    }
+}
+
+xmlNodePtr
+printDescribeProcessHeader (xmlDocPtr doc, const char *service, maps * m)
+{
+
+  xmlNsPtr ns, ns_xsi;
   xmlNodePtr n;
 
-  int wpsId=zooXmlAddNs(NULL,"http://schemas.opengis.net/wps/1.0.0","wps");
-  ns=usedNs[wpsId];
-  n = xmlNewNode(ns, BAD_CAST "ProcessDescriptions");
-  zooXmlAddNs(n,"http://www.opengis.net/ows/1.1","ows");
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
-  int xsiId=zooXmlAddNs(n,"http://www.w3.org/2001/XMLSchema-instance","xsi");
-  ns_xsi=usedNs[xsiId];
-  
-  xmlNewNsProp(n,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsDescribeProcess_response.xsd");
-  xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
-  xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-  addLangAttr(n,m);
-
-  xmlNodePtr fn=soapEnvelope(m,n);
-  xmlDocSetRootElement(doc, fn);
+  int wpsId =
+    zooXmlAddNs (NULL, "http://schemas.opengis.net/wps/1.0.0", "wps");
+  ns = usedNs[wpsId];
+  n = xmlNewNode (ns, BAD_CAST "ProcessDescriptions");
+  zooXmlAddNs (n, "http://www.opengis.net/ows/1.1", "ows");
+  xmlNewNs (n, BAD_CAST "http://www.opengis.net/wps/1.0.0", BAD_CAST "wps");
+  zooXmlAddNs (n, "http://www.w3.org/1999/xlink", "xlink");
+  int xsiId =
+    zooXmlAddNs (n, "http://www.w3.org/2001/XMLSchema-instance", "xsi");
+  ns_xsi = usedNs[xsiId];
+
+  xmlNewNsProp (n, ns_xsi, BAD_CAST "schemaLocation",
+                BAD_CAST
+                "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsDescribeProcess_response.xsd");
+  xmlNewProp (n, BAD_CAST "service", BAD_CAST "WPS");
+  xmlNewProp (n, BAD_CAST "version", BAD_CAST "1.0.0");
+  addLangAttr (n, m);
+
+  xmlNodePtr fn = soapEnvelope (m, n);
+  xmlDocSetRootElement (doc, fn);
 
   return n;
 }
 
-void printDescribeProcessForProcess(maps* m,xmlNodePtr nc,service* serv){
-  xmlNsPtr ns,ns_ows,ns_xlink;
-  xmlNodePtr n,nc1;
-
-  n=nc;
-  
-  int wpsId=zooXmlAddNs(NULL,"http://schemas.opengis.net/wps/1.0.0","wps");
-  ns=usedNs[wpsId];
-  int owsId=zooXmlAddNs(NULL,"http://www.opengis.net/ows/1.1","ows");
-  ns_ows=usedNs[owsId];
-  int xlinkId=zooXmlAddNs(NULL,"http://www.w3.org/1999/xlink","xlink");
-  ns_xlink=usedNs[xlinkId];
-
-  nc = xmlNewNode(NULL, BAD_CAST "ProcessDescription");
+void
+printDescribeProcessForProcess (maps * m, xmlNodePtr nc, service * serv)
+{
+  xmlNsPtr ns, ns_ows, ns_xlink;
+  xmlNodePtr n, nc1;
+
+  n = nc;
+
+  int wpsId =
+    zooXmlAddNs (NULL, "http://schemas.opengis.net/wps/1.0.0", "wps");
+  ns = usedNs[wpsId];
+  int owsId = zooXmlAddNs (NULL, "http://www.opengis.net/ows/1.1", "ows");
+  ns_ows = usedNs[owsId];
+  int xlinkId = zooXmlAddNs (NULL, "http://www.w3.org/1999/xlink", "xlink");
+  ns_xlink = usedNs[xlinkId];
+
+  nc = xmlNewNode (NULL, BAD_CAST "ProcessDescription");
   const char *tmp4[3];
-  tmp4[0]="processVersion";
-  tmp4[1]="storeSupported";
-  tmp4[2]="statusSupported";
-  int j=0;
-  map* tmp1=NULL;
-  for(j=0;j<3;j++){
-    tmp1=getMap(serv->content,tmp4[j]);
-    if(tmp1!=NULL){
-      if(j==0)
-	xmlNewNsProp(nc,ns,BAD_CAST "processVersion",BAD_CAST tmp1->value);      
+  tmp4[0] = "processVersion";
+  tmp4[1] = "storeSupported";
+  tmp4[2] = "statusSupported";
+  int j = 0;
+  map *tmp1 = NULL;
+  for (j = 0; j < 3; j++)
+    {
+      tmp1 = getMap (serv->content, tmp4[j]);
+      if (tmp1 != NULL)
+        {
+          if (j == 0)
+            xmlNewNsProp (nc, ns, BAD_CAST "processVersion",
+                          BAD_CAST tmp1->value);
+          else
+            xmlNewProp (nc, BAD_CAST tmp4[j], BAD_CAST tmp1->value);
+        }
       else
-	xmlNewProp(nc,BAD_CAST tmp4[j],BAD_CAST tmp1->value);      
-    }
-    else{
-      if(j>0)
-	xmlNewProp(nc,BAD_CAST tmp4[j],BAD_CAST "false");      
-    }
-  }
-  
-  tmp1=getMapFromMaps(m,"lenv","level");
-  addPrefix(m,tmp1,serv);
-  printDescription(nc,ns_ows,serv->name,serv->content);
-
-  tmp1=serv->metadata;
-  while(tmp1!=NULL){
-    nc1 = xmlNewNode(ns_ows, BAD_CAST "Metadata");
-    xmlNewNsProp(nc1,ns_xlink,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-    xmlAddChild(nc,nc1);
-    tmp1=tmp1->next;
-  }
-
-  tmp1=getMap(serv->content,"Profile");
-  if(tmp1!=NULL){
-    nc1 = xmlNewNode(ns, BAD_CAST "Profile");
-    xmlAddChild(nc1,xmlNewText(BAD_CAST tmp1->value));
-    xmlAddChild(nc,nc1);
-  }
-
-  if(serv->inputs!=NULL){
-    nc1 = xmlNewNode(NULL, BAD_CAST "DataInputs");
-    elements* e=serv->inputs;
-    printFullDescription(1,e,"Input",ns_ows,nc1);
-    xmlAddChild(nc,nc1);
-  }
-
-  nc1 = xmlNewNode(NULL, BAD_CAST "ProcessOutputs");
-  elements* e=serv->outputs;
-  printFullDescription(0,e,"Output",ns_ows,nc1);
-  xmlAddChild(nc,nc1);
-
-  xmlAddChild(n,nc);
-
-}
-
-void printFullDescription(int in,elements *elem,const char* type,xmlNsPtr ns_ows,xmlNodePtr nc1){
+        {
+          if (j > 0)
+            xmlNewProp (nc, BAD_CAST tmp4[j], BAD_CAST "false");
+        }
+    }
+
+  tmp1 = getMapFromMaps (m, "lenv", "level");
+  addPrefix (m, tmp1, serv);
+  printDescription (nc, ns_ows, serv->identifier, serv->content);
+
+  tmp1 = serv->metadata;
+  while (tmp1 != NULL)
+    {
+      nc1 = xmlNewNode (ns_ows, BAD_CAST "Metadata");
+      xmlNewNsProp (nc1, ns_xlink, BAD_CAST tmp1->name, BAD_CAST tmp1->value);
+      xmlAddChild (nc, nc1);
+      tmp1 = tmp1->next;
+    }
+
+  tmp1 = getMap (serv->content, "Profile");
+  if (tmp1 != NULL)
+    {
+      nc1 = xmlNewNode (ns, BAD_CAST "Profile");
+      xmlAddChild (nc1, xmlNewText (BAD_CAST tmp1->value));
+      xmlAddChild (nc, nc1);
+    }
+
+  if (serv->inputs != NULL)
+    {
+      nc1 = xmlNewNode (NULL, BAD_CAST "DataInputs");
+      elements *e = serv->inputs;
+      printFullDescription (1, e, "Input", ns_ows, nc1);
+      xmlAddChild (nc, nc1);
+    }
+
+  nc1 = xmlNewNode (NULL, BAD_CAST "ProcessOutputs");
+  elements *e = serv->outputs;
+  printFullDescription (0, e, "Output", ns_ows, nc1);
+  xmlAddChild (nc, nc1);
+
+  xmlAddChild (n, nc);
+
+}
+
+void
+printFullDescription (int in, elements * elem, const char *type,
+                      xmlNsPtr ns_ows, xmlNodePtr nc1)
+{
   const char *orderedFields[13];
-  orderedFields[0]="mimeType";
-  orderedFields[1]="encoding";
-  orderedFields[2]="schema";
-  orderedFields[3]="dataType";
-  orderedFields[4]="uom";
-  orderedFields[5]="CRS";
-  orderedFields[6]="value";
-  orderedFields[7]="AllowedValues";
-  orderedFields[8]="range";
-  orderedFields[9]="rangeMin";
-  orderedFields[10]="rangeMax";
-  orderedFields[11]="rangeClosure";
-  orderedFields[12]="rangeSpace";
-
-  xmlNodePtr nc2,nc3,nc4,nc5,nc6,nc7,nc8,nc9;
-  elements* e=elem;
-
-  map* tmp1=NULL;
-  while(e!=NULL){
-    int default1=0;
-    int isAnyValue=1;
-    nc2 = xmlNewNode(NULL, BAD_CAST type);
-    if(strncmp(type,"Input",5)==0){
-      tmp1=getMap(e->content,"minOccurs");
-      if(tmp1!=NULL){
-	xmlNewProp(nc2,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-      }else
-	xmlNewProp(nc2,BAD_CAST "minOccurs",BAD_CAST "0");
-      tmp1=getMap(e->content,"maxOccurs");
-      if(tmp1!=NULL){
-	if(strcasecmp(tmp1->value,"unbounded")!=0)
-	  xmlNewProp(nc2,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-	else
-	  xmlNewProp(nc2,BAD_CAST "maxOccurs",BAD_CAST "1000");
-      }else
-	xmlNewProp(nc2,BAD_CAST "maxOccurs",BAD_CAST "1");
-      if((tmp1=getMap(e->content,"maximumMegabytes"))!=NULL){
-	xmlNewProp(nc2,BAD_CAST "maximumMegabytes",BAD_CAST tmp1->value);
-      }
-    }
-
-    printDescription(nc2,ns_ows,e->name,e->content);
+  orderedFields[0] = "mimeType";
+  orderedFields[1] = "encoding";
+  orderedFields[2] = "schema";
+  orderedFields[3] = "dataType";
+  orderedFields[4] = "uom";
+  orderedFields[5] = "CRS";
+  orderedFields[6] = "value";
+  orderedFields[7] = "AllowedValues";
+  orderedFields[8] = "range";
+  orderedFields[9] = "rangeMin";
+  orderedFields[10] = "rangeMax";
+  orderedFields[11] = "rangeClosure";
+  orderedFields[12] = "rangeSpace";
+
+  xmlNodePtr nc2, nc3, nc4, nc5, nc6, nc7, nc8, nc9;
+  elements *e = elem;
+
+  map *tmp1 = NULL;
+  while (e != NULL)
+    {
+      int default1 = 0;
+      int isAnyValue = 1;
+      nc2 = xmlNewNode (NULL, BAD_CAST type);
+      if (strncmp (type, "Input", 5) == 0)
+        {
+          tmp1 = getMap (e->content, "minOccurs");
+          if (tmp1 != NULL)
+            {
+              xmlNewProp (nc2, BAD_CAST tmp1->name, BAD_CAST tmp1->value);
+            }
+          else
+            xmlNewProp (nc2, BAD_CAST "minOccurs", BAD_CAST "0");
+          tmp1 = getMap (e->content, "maxOccurs");
+          if (tmp1 != NULL)
+            {
+              if (strcasecmp (tmp1->value, "unbounded") != 0)
+                xmlNewProp (nc2, BAD_CAST tmp1->name, BAD_CAST tmp1->value);
+              else
+                xmlNewProp (nc2, BAD_CAST "maxOccurs", BAD_CAST "1000");
+            }
+          else
+            xmlNewProp (nc2, BAD_CAST "maxOccurs", BAD_CAST "1");
+          if ((tmp1 = getMap (e->content, "maximumMegabytes")) != NULL)
+            {
+              xmlNewProp (nc2, BAD_CAST "maximumMegabytes",
+                          BAD_CAST tmp1->value);
+            }
+        }
+
+      printDescription (nc2, ns_ows, e->name, e->content);
 
     /**
      * Build the (Literal/Complex/BoundingBox)Data node
      */
-    if(strncmp(type,"Output",6)==0){
-      if(strncasecmp(e->format,"LITERALDATA",strlen(e->format))==0)
-	nc3 = xmlNewNode(NULL, BAD_CAST "LiteralOutput");
-      else if(strncasecmp(e->format,"COMPLEXDATA",strlen(e->format))==0)
-	nc3 = xmlNewNode(NULL, BAD_CAST "ComplexOutput");
-      else if(strncasecmp(e->format,"BOUNDINGBOXDATA",strlen(e->format))==0)
-	nc3 = xmlNewNode(NULL, BAD_CAST "BoundingBoxOutput");
+      if (strncmp (type, "Output", 6) == 0)
+        {
+          if (strncasecmp (e->format, "LITERALDATA", strlen (e->format)) == 0)
+            nc3 = xmlNewNode (NULL, BAD_CAST "LiteralOutput");
+          else if (strncasecmp (e->format, "COMPLEXDATA", strlen (e->format))
+                   == 0)
+            nc3 = xmlNewNode (NULL, BAD_CAST "ComplexOutput");
+          else
+            if (strncasecmp (e->format, "BOUNDINGBOXDATA", strlen (e->format))
+                == 0)
+            nc3 = xmlNewNode (NULL, BAD_CAST "BoundingBoxOutput");
+          else
+            nc3 = xmlNewNode (NULL, BAD_CAST e->format);
+        }
       else
-	nc3 = xmlNewNode(NULL, BAD_CAST e->format);
-    }else{
-      if(strncasecmp(e->format,"LITERALDATA",strlen(e->format))==0){
-	nc3 = xmlNewNode(NULL, BAD_CAST "LiteralData");
-      }
-      else if(strncasecmp(e->format,"COMPLEXDATA",strlen(e->format))==0)
-	nc3 = xmlNewNode(NULL, BAD_CAST "ComplexData");
-      else if(strncasecmp(e->format,"BOUNDINGBOXDATA",strlen(e->format))==0)
-	nc3 = xmlNewNode(NULL, BAD_CAST "BoundingBoxData");
-      else
-	nc3 = xmlNewNode(NULL, BAD_CAST e->format);
-    }
-
-    iotype* _tmp0=NULL;
-    iotype* _tmp=e->defaults;
-    int datatype=0;
-    bool hasUOM=false;
-    bool hasUOM1=false;
-    if(_tmp!=NULL){
-      if(strcmp(e->format,"LiteralOutput")==0 ||
-	 strcmp(e->format,"LiteralData")==0){
-     	datatype=1;
-	nc4 = xmlNewNode(NULL, BAD_CAST "UOMs");
-	nc5 = xmlNewNode(NULL, BAD_CAST "Default");
-      }
-      else if(strcmp(e->format,"BoundingBoxOutput")==0 ||
-	      strcmp(e->format,"BoundingBoxData")==0){
-	datatype=2;
-	nc5 = xmlNewNode(NULL, BAD_CAST "Default");
-      }
-      else{
-	nc4 = xmlNewNode(NULL, BAD_CAST "Default");
-	nc5 = xmlNewNode(NULL, BAD_CAST "Format");
-      }
-      
-      tmp1=_tmp->content;
-
-      if((tmp1=getMap(_tmp->content,"DataType"))!=NULL){
-	nc8 = xmlNewNode(ns_ows, BAD_CAST "DataType");
-	xmlAddChild(nc8,xmlNewText(BAD_CAST tmp1->value));
-	char tmp[1024];
-	sprintf(tmp,"http://www.w3.org/TR/xmlschema-2/#%s",tmp1->value);
-	xmlNewNsProp(nc8,ns_ows,BAD_CAST "reference",BAD_CAST tmp);
-	xmlAddChild(nc3,nc8);
-	datatype=1;
-      }
-      
-      if(strncmp(type,"Input",5)==0){
-
-	if((tmp1=getMap(_tmp->content,"AllowedValues"))!=NULL){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST "AllowedValues");
-	  char *token,*saveptr1;
-	  token=strtok_r(tmp1->value,",",&saveptr1);
-	  while(token!=NULL){
-	    nc7 = xmlNewNode(ns_ows, BAD_CAST "Value");
-	    char *tmps=strdup(token);
-	    tmps[strlen(tmps)]=0;
-	    xmlAddChild(nc7,xmlNewText(BAD_CAST tmps));
-	    free(tmps);
-	    xmlAddChild(nc6,nc7);
-	    token=strtok_r(NULL,",",&saveptr1);
-	  }
-	  if(getMap(_tmp->content,"range")!=NULL ||
-	     getMap(_tmp->content,"rangeMin")!=NULL ||
-	     getMap(_tmp->content,"rangeMax")!=NULL ||
-	     getMap(_tmp->content,"rangeClosure")!=NULL )
-	    goto doRange;
-	  xmlAddChild(nc3,nc6);
-	  isAnyValue=-1;
-	}
-
-        tmp1=getMap(_tmp->content,"range");
-	if(tmp1==NULL)
-	  tmp1=getMap(_tmp->content,"rangeMin");
-	if(tmp1==NULL)
-	  tmp1=getMap(_tmp->content,"rangeMax");
-	
-	if(tmp1!=NULL && isAnyValue==1){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST "AllowedValues");
-	doRange:
-	  
-	  /**
+        {
+          if (strncasecmp (e->format, "LITERALDATA", strlen (e->format)) == 0)
+            {
+              nc3 = xmlNewNode (NULL, BAD_CAST "LiteralData");
+            }
+          else if (strncasecmp (e->format, "COMPLEXDATA", strlen (e->format))
+                   == 0)
+            nc3 = xmlNewNode (NULL, BAD_CAST "ComplexData");
+          else
+            if (strncasecmp (e->format, "BOUNDINGBOXDATA", strlen (e->format))
+                == 0)
+            nc3 = xmlNewNode (NULL, BAD_CAST "BoundingBoxData");
+          else
+            nc3 = xmlNewNode (NULL, BAD_CAST e->format);
+        }
+
+      iotype *_tmp0 = NULL;
+      iotype *_tmp = e->defaults;
+      int datatype = 0;
+      bool hasUOM = false;
+      bool hasUOM1 = false;
+      if (_tmp != NULL)
+        {
+          if (strcmp (e->format, "LiteralOutput") == 0 ||
+              strcmp (e->format, "LiteralData") == 0)
+            {
+              datatype = 1;
+              nc4 = xmlNewNode (NULL, BAD_CAST "UOMs");
+              nc5 = xmlNewNode (NULL, BAD_CAST "Default");
+            }
+          else if (strcmp (e->format, "BoundingBoxOutput") == 0 ||
+                   strcmp (e->format, "BoundingBoxData") == 0)
+            {
+              datatype = 2;
+              nc5 = xmlNewNode (NULL, BAD_CAST "Default");
+            }
+          else
+            {
+              nc4 = xmlNewNode (NULL, BAD_CAST "Default");
+              nc5 = xmlNewNode (NULL, BAD_CAST "Format");
+            }
+
+          tmp1 = _tmp->content;
+
+          if ((tmp1 = getMap (_tmp->content, "DataType")) != NULL)
+            {
+              nc8 = xmlNewNode (ns_ows, BAD_CAST "DataType");
+              xmlAddChild (nc8, xmlNewText (BAD_CAST tmp1->value));
+              char tmp[1024];
+              sprintf (tmp, "http://www.w3.org/TR/xmlschema-2/#%s",
+                       tmp1->value);
+              xmlNewNsProp (nc8, ns_ows, BAD_CAST "reference", BAD_CAST tmp);
+              xmlAddChild (nc3, nc8);
+              datatype = 1;
+            }
+
+          if (strncmp (type, "Input", 5) == 0)
+            {
+
+              if ((tmp1 = getMap (_tmp->content, "AllowedValues")) != NULL)
+                {
+                  nc6 = xmlNewNode (ns_ows, BAD_CAST "AllowedValues");
+                  char *token, *saveptr1;
+                  token = strtok_r (tmp1->value, ",", &saveptr1);
+                  while (token != NULL)
+                    {
+                      nc7 = xmlNewNode (ns_ows, BAD_CAST "Value");
+                      char *tmps = strdup (token);
+                      tmps[strlen (tmps)] = 0;
+                      xmlAddChild (nc7, xmlNewText (BAD_CAST tmps));
+                      free (tmps);
+                      xmlAddChild (nc6, nc7);
+                      token = strtok_r (NULL, ",", &saveptr1);
+                    }
+                  if (getMap (_tmp->content, "range") != NULL ||
+                      getMap (_tmp->content, "rangeMin") != NULL ||
+                      getMap (_tmp->content, "rangeMax") != NULL ||
+                      getMap (_tmp->content, "rangeClosure") != NULL)
+                    goto doRange;
+                  xmlAddChild (nc3, nc6);
+                  isAnyValue = -1;
+                }
+
+              tmp1 = getMap (_tmp->content, "range");
+              if (tmp1 == NULL)
+                tmp1 = getMap (_tmp->content, "rangeMin");
+              if (tmp1 == NULL)
+                tmp1 = getMap (_tmp->content, "rangeMax");
+
+              if (tmp1 != NULL && isAnyValue == 1)
+                {
+                  nc6 = xmlNewNode (ns_ows, BAD_CAST "AllowedValues");
+                doRange:
+
+          /**
 	   * Range: Table 46 OGC Web Services Common Standard
 	   */
-	  nc8 = xmlNewNode(ns_ows, BAD_CAST "Range");
-	  
-	  map* tmp0=getMap(tmp1,"range");
-	  if(tmp0!=NULL){
-	    char* pToken;
-	    char* orig=zStrdup(tmp0->value);
-	    /**
+                  nc8 = xmlNewNode (ns_ows, BAD_CAST "Range");
+
+                  map *tmp0 = getMap (tmp1, "range");
+                  if (tmp0 != NULL)
+                    {
+                      char *pToken;
+                      char *orig = zStrdup (tmp0->value);
+            /**
 	     * RangeClosure: Table 47 OGC Web Services Common Standard
 	     */
-	    const char *tmp="closed";
-	    if(orig[0]=='[' && orig[strlen(orig)-1]=='[')
-	      tmp="closed-open";
-	    else
-	      if(orig[0]==']' && orig[strlen(orig)-1]==']')
-		tmp="open-closed";
-	      else
-		if(orig[0]==']' && orig[strlen(orig)-1]=='[')
-		  tmp="open";
-	    xmlNewNsProp(nc8,ns_ows,BAD_CAST "rangeClosure",BAD_CAST tmp);
-	    pToken=strtok(orig,",");
-	    int nci0=0;
-	    while(pToken!=NULL){
-	      char *tmpStr=(char*) malloc((strlen(pToken))*sizeof(char));
-	      if(nci0==0){
-		nc7 = xmlNewNode(ns_ows, BAD_CAST "MinimumValue");
-		int nci=1;
-		for(nci=1;nci<strlen(pToken);nci++){
-		  tmpStr[nci-1]=pToken[nci];
-		}
-		}else{
-		nc7 = xmlNewNode(ns_ows, BAD_CAST "MaximumValue");
-		int nci=0;
-		for(nci=0;nci<strlen(pToken)-1;nci++){
-		  tmpStr[nci]=pToken[nci];
-		}
-	      }
-	      xmlAddChild(nc7,xmlNewText(BAD_CAST tmpStr));
-	      free(tmpStr);
-	      xmlAddChild(nc8,nc7);
-	      nci0++;
-	      pToken = strtok(NULL,",");
-	    }		    
-	    if(getMap(tmp1,"rangeSpacing")==NULL){
-	      nc7 = xmlNewNode(ns_ows, BAD_CAST "Spacing");
-	      xmlAddChild(nc7,xmlNewText(BAD_CAST "1"));
-	      xmlAddChild(nc8,nc7);
-	    }
-	    free(orig);
-	  }else{
-	    
-	    tmp0=getMap(tmp1,"rangeMin");
-	    if(tmp0!=NULL){
-	      nc7 = xmlNewNode(ns_ows, BAD_CAST "MinimumValue");
-	      xmlAddChild(nc7,xmlNewText(BAD_CAST tmp0->value));
-	      xmlAddChild(nc8,nc7);
-	    }else{
-	      nc7 = xmlNewNode(ns_ows, BAD_CAST "MinimumValue");
-	      xmlAddChild(nc8,nc7);
-	    }
-	    tmp0=getMap(tmp1,"rangeMax");
-	    if(tmp0!=NULL){
-	      nc7 = xmlNewNode(ns_ows, BAD_CAST "MaximumValue");
-	      xmlAddChild(nc7,xmlNewText(BAD_CAST tmp0->value));
-	      xmlAddChild(nc8,nc7);
-	    }else{
-	      nc7 = xmlNewNode(ns_ows, BAD_CAST "MaximumValue");
-	      xmlAddChild(nc8,nc7);
-	    }
-	    tmp0=getMap(tmp1,"rangeSpacing");
-	    if(tmp0!=NULL){
-	      nc7 = xmlNewNode(ns_ows, BAD_CAST "Spacing");
-	      xmlAddChild(nc7,xmlNewText(BAD_CAST tmp0->value));
-	      xmlAddChild(nc8,nc7);
-	    }
-	    tmp0=getMap(tmp1,"rangeClosure");
-	    if(tmp0!=NULL){
-	      const char *tmp="closed";
-	      if(strcasecmp(tmp0->value,"co")==0)
-		tmp="closed-open";
-	      else
-		if(strcasecmp(tmp0->value,"oc")==0)
-		  tmp="open-closed";
-		else
-		  if(strcasecmp(tmp0->value,"o")==0)
-		    tmp="open";
-	      xmlNewNsProp(nc8,ns_ows,BAD_CAST "rangeClosure",BAD_CAST tmp);
-	    }else
-	      xmlNewNsProp(nc8,ns_ows,BAD_CAST "rangeClosure",BAD_CAST "closed");
-	  }
-	  if(_tmp0==NULL){
-	    xmlAddChild(nc6,nc8);
-	    _tmp0=e->supported;
-	    if(getMap(_tmp0->content,"range")!=NULL ||
-	       getMap(_tmp0->content,"rangeMin")!=NULL ||
-	       getMap(_tmp0->content,"rangeMax")!=NULL ||
-	       getMap(_tmp0->content,"rangeClosure")!=NULL ){
-	      tmp1=_tmp0->content;
-	      goto doRange;
-	    }
-	  }else{
-	    _tmp0=_tmp0->next;
-	    if(_tmp0!=NULL){
-	      xmlAddChild(nc6,nc8);
-	      if(getMap(_tmp0->content,"range")!=NULL ||
-		 getMap(_tmp0->content,"rangeMin")!=NULL ||
-		 getMap(_tmp0->content,"rangeMax")!=NULL ||
-		 getMap(_tmp0->content,"rangeClosure")!=NULL ){
-		tmp1=_tmp0->content;
-		goto doRange;
-	      }
-	    }
-	  }
-	  xmlAddChild(nc6,nc8);
-	  xmlAddChild(nc3,nc6);
-	  isAnyValue=-1;
-	}
-	
-      }
-    
-      
-    int oI=0;
-    for(oI=0;oI<13;oI++)
-      if((tmp1=getMap(_tmp->content,orderedFields[oI]))!=NULL){
+                      const char *tmp = "closed";
+                      if (orig[0] == '[' && orig[strlen (orig) - 1] == '[')
+                        tmp = "closed-open";
+                      else
+                        if (orig[0] == ']' && orig[strlen (orig) - 1] == ']')
+                        tmp = "open-closed";
+                      else
+                        if (orig[0] == ']' && orig[strlen (orig) - 1] == '[')
+                        tmp = "open";
+                      xmlNewNsProp (nc8, ns_ows, BAD_CAST "rangeClosure",
+                                    BAD_CAST tmp);
+                      pToken = strtok (orig, ",");
+                      int nci0 = 0;
+                      while (pToken != NULL)
+                        {
+                          char *tmpStr =
+                            (char *) malloc ((strlen (pToken)) *
+                                             sizeof (char));
+                          if (nci0 == 0)
+                            {
+                              nc7 =
+                                xmlNewNode (ns_ows, BAD_CAST "MinimumValue");
+                              int nci = 1;
+                              for (nci = 1; nci < strlen (pToken); nci++)
+                                {
+                                  tmpStr[nci - 1] = pToken[nci];
+                                }
+                            }
+                          else
+                            {
+                              nc7 =
+                                xmlNewNode (ns_ows, BAD_CAST "MaximumValue");
+                              int nci = 0;
+                              for (nci = 0; nci < strlen (pToken) - 1; nci++)
+                                {
+                                  tmpStr[nci] = pToken[nci];
+                                }
+                            }
+                          xmlAddChild (nc7, xmlNewText (BAD_CAST tmpStr));
+                          free (tmpStr);
+                          xmlAddChild (nc8, nc7);
+                          nci0++;
+                          pToken = strtok (NULL, ",");
+                        }
+                      if (getMap (tmp1, "rangeSpacing") == NULL)
+                        {
+                          nc7 = xmlNewNode (ns_ows, BAD_CAST "Spacing");
+                          xmlAddChild (nc7, xmlNewText (BAD_CAST "1"));
+                          xmlAddChild (nc8, nc7);
+                        }
+                      free (orig);
+                    }
+                  else
+                    {
+
+                      tmp0 = getMap (tmp1, "rangeMin");
+                      if (tmp0 != NULL)
+                        {
+                          nc7 = xmlNewNode (ns_ows, BAD_CAST "MinimumValue");
+                          xmlAddChild (nc7,
+                                       xmlNewText (BAD_CAST tmp0->value));
+                          xmlAddChild (nc8, nc7);
+                        }
+                      else
+                        {
+                          nc7 = xmlNewNode (ns_ows, BAD_CAST "MinimumValue");
+                          xmlAddChild (nc8, nc7);
+                        }
+                      tmp0 = getMap (tmp1, "rangeMax");
+                      if (tmp0 != NULL)
+                        {
+                          nc7 = xmlNewNode (ns_ows, BAD_CAST "MaximumValue");
+                          xmlAddChild (nc7,
+                                       xmlNewText (BAD_CAST tmp0->value));
+                          xmlAddChild (nc8, nc7);
+                        }
+                      else
+                        {
+                          nc7 = xmlNewNode (ns_ows, BAD_CAST "MaximumValue");
+                          xmlAddChild (nc8, nc7);
+                        }
+                      tmp0 = getMap (tmp1, "rangeSpacing");
+                      if (tmp0 != NULL)
+                        {
+                          nc7 = xmlNewNode (ns_ows, BAD_CAST "Spacing");
+                          xmlAddChild (nc7,
+                                       xmlNewText (BAD_CAST tmp0->value));
+                          xmlAddChild (nc8, nc7);
+                        }
+                      tmp0 = getMap (tmp1, "rangeClosure");
+                      if (tmp0 != NULL)
+                        {
+                          const char *tmp = "closed";
+                          if (strcasecmp (tmp0->value, "co") == 0)
+                            tmp = "closed-open";
+                          else if (strcasecmp (tmp0->value, "oc") == 0)
+                            tmp = "open-closed";
+                          else if (strcasecmp (tmp0->value, "o") == 0)
+                            tmp = "open";
+                          xmlNewNsProp (nc8, ns_ows, BAD_CAST "rangeClosure",
+                                        BAD_CAST tmp);
+                        }
+                      else
+                        xmlNewNsProp (nc8, ns_ows, BAD_CAST "rangeClosure",
+                                      BAD_CAST "closed");
+                    }
+                  if (_tmp0 == NULL)
+                    {
+                      xmlAddChild (nc6, nc8);
+                      _tmp0 = e->supported;
+                      if (getMap (_tmp0->content, "range") != NULL ||
+                          getMap (_tmp0->content, "rangeMin") != NULL ||
+                          getMap (_tmp0->content, "rangeMax") != NULL ||
+                          getMap (_tmp0->content, "rangeClosure") != NULL)
+                        {
+                          tmp1 = _tmp0->content;
+                          goto doRange;
+                        }
+                    }
+                  else
+                    {
+                      _tmp0 = _tmp0->next;
+                      if (_tmp0 != NULL)
+                        {
+                          xmlAddChild (nc6, nc8);
+                          if (getMap (_tmp0->content, "range") != NULL ||
+                              getMap (_tmp0->content, "rangeMin") != NULL ||
+                              getMap (_tmp0->content, "rangeMax") != NULL ||
+                              getMap (_tmp0->content, "rangeClosure") != NULL)
+                            {
+                              tmp1 = _tmp0->content;
+                              goto doRange;
+                            }
+                        }
+                    }
+                  xmlAddChild (nc6, nc8);
+                  xmlAddChild (nc3, nc6);
+                  isAnyValue = -1;
+                }
+
+            }
+
+
+          int oI = 0;
+          for (oI = 0; oI < 13; oI++)
+            if ((tmp1 = getMap (_tmp->content, orderedFields[oI])) != NULL)
+              {
 #ifdef DEBUG
-	printf("DATATYPE DEFAULT ? %s\n",tmp1->name);
-#endif
-	if(strcmp(tmp1->name,"asReference")!=0 &&
-	   strncasecmp(tmp1->name,"DataType",8)!=0 &&
-	   strcasecmp(tmp1->name,"extension")!=0 &&
-	   strcasecmp(tmp1->name,"value")!=0 &&
-	   strcasecmp(tmp1->name,"AllowedValues")!=0 &&
-	   strncasecmp(tmp1->name,"range",5)!=0){
-	  if(datatype!=1){
-	    char *tmp2=zCapitalize1(tmp1->name);
-	    nc9 = xmlNewNode(NULL, BAD_CAST tmp2);
-	    free(tmp2);
-	  }
-	  else{
-	    char *tmp2=zCapitalize(tmp1->name);
-	    nc9 = xmlNewNode(ns_ows, BAD_CAST tmp2);
-	    free(tmp2);
-	  }
-	  xmlAddChild(nc9,xmlNewText(BAD_CAST tmp1->value));
-	  xmlAddChild(nc5,nc9);
-	  if(strcasecmp(tmp1->name,"uom")==0)
-	    hasUOM1=true;
-	  hasUOM=true;
-	}else 
-	  
-	  tmp1=tmp1->next;
-      }
-    
-    
-      if(datatype!=2){
-	if(hasUOM==true){
-	  xmlAddChild(nc4,nc5);
-	  xmlAddChild(nc3,nc4);
-	}else{
-	  if(hasUOM1==false){
-	    xmlFreeNode(nc5);
-	    if(datatype==1)
-	      xmlFreeNode(nc4);
-	  }
-	}
-      }else{
-	xmlAddChild(nc3,nc5);
-      }
-      
-      if(datatype!=1 && default1<0){
-	xmlFreeNode(nc5);
-	if(datatype!=2)
-	  xmlFreeNode(nc4);
-      }
-
-      map* metadata=e->metadata;
-      xmlNodePtr n=NULL;
-      int xlinkId=zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
-      xmlNsPtr ns_xlink=usedNs[xlinkId];
-
-      while(metadata!=NULL){
-	nc6=xmlNewNode(ns_ows, BAD_CAST "Metadata");
-	xmlNewNsProp(nc6,ns_xlink,BAD_CAST metadata->name,BAD_CAST metadata->value);
-	xmlAddChild(nc2,nc6);
-	metadata=metadata->next;
-      }
-
-    }
-
-    _tmp=e->supported;
-    if(_tmp==NULL && datatype!=1)
-      _tmp=e->defaults;
-
-    int hasSupported=-1;
-
-    while(_tmp!=NULL){
-      if(hasSupported<0){
-	if(datatype==0){
-	  nc4 = xmlNewNode(NULL, BAD_CAST "Supported");
-	  nc5 = xmlNewNode(NULL, BAD_CAST "Format");
-	}
-	else
-	  nc5 = xmlNewNode(NULL, BAD_CAST "Supported");
-	hasSupported=0;
-      }else
-	if(datatype==0)
-	  nc5 = xmlNewNode(NULL, BAD_CAST "Format");
-      tmp1=_tmp->content;
-      int oI=0;
-      for(oI=0;oI<6;oI++)
-	if((tmp1=getMap(_tmp->content,orderedFields[oI]))!=NULL){
+                printf ("DATATYPE DEFAULT ? %s\n", tmp1->name);
+#endif
+                if (strcmp (tmp1->name, "asReference") != 0 &&
+                    strncasecmp (tmp1->name, "DataType", 8) != 0 &&
+                    strcasecmp (tmp1->name, "extension") != 0 &&
+                    strcasecmp (tmp1->name, "value") != 0 &&
+                    strcasecmp (tmp1->name, "AllowedValues") != 0 &&
+                    strncasecmp (tmp1->name, "range", 5) != 0)
+                  {
+                    if (datatype != 1)
+                      {
+                        char *tmp2 = zCapitalize1 (tmp1->name);
+                        nc9 = xmlNewNode (NULL, BAD_CAST tmp2);
+                        free (tmp2);
+                      }
+                    else
+                      {
+                        char *tmp2 = zCapitalize (tmp1->name);
+                        nc9 = xmlNewNode (ns_ows, BAD_CAST tmp2);
+                        free (tmp2);
+                      }
+                    xmlAddChild (nc9, xmlNewText (BAD_CAST tmp1->value));
+                    xmlAddChild (nc5, nc9);
+                    if (strcasecmp (tmp1->name, "uom") == 0)
+                      hasUOM1 = true;
+                    hasUOM = true;
+                  }
+                else
+
+                  tmp1 = tmp1->next;
+              }
+
+
+          if (datatype != 2)
+            {
+              if (hasUOM == true)
+                {
+                  xmlAddChild (nc4, nc5);
+                  xmlAddChild (nc3, nc4);
+                }
+              else
+                {
+                  if (hasUOM1 == false)
+                    {
+                      xmlFreeNode (nc5);
+                      if (datatype == 1)
+                        xmlFreeNode (nc4);
+                    }
+                }
+            }
+          else
+            {
+              xmlAddChild (nc3, nc5);
+            }
+
+          if (datatype != 1 && default1 < 0)
+            {
+              xmlFreeNode (nc5);
+              if (datatype != 2)
+                xmlFreeNode (nc4);
+            }
+
+          map *metadata = e->metadata;
+          xmlNodePtr n = NULL;
+          int xlinkId =
+            zooXmlAddNs (n, "http://www.w3.org/1999/xlink", "xlink");
+          xmlNsPtr ns_xlink = usedNs[xlinkId];
+
+          while (metadata != NULL)
+            {
+              nc6 = xmlNewNode (ns_ows, BAD_CAST "Metadata");
+              xmlNewNsProp (nc6, ns_xlink, BAD_CAST metadata->name,
+                            BAD_CAST metadata->value);
+              xmlAddChild (nc2, nc6);
+              metadata = metadata->next;
+            }
+
+        }
+
+      _tmp = e->supported;
+      if (_tmp == NULL && datatype != 1)
+        _tmp = e->defaults;
+
+      int hasSupported = -1;
+
+      while (_tmp != NULL)
+        {
+          if (hasSupported < 0)
+            {
+              if (datatype == 0)
+                {
+                  nc4 = xmlNewNode (NULL, BAD_CAST "Supported");
+                  nc5 = xmlNewNode (NULL, BAD_CAST "Format");
+                }
+              else
+                nc5 = xmlNewNode (NULL, BAD_CAST "Supported");
+              hasSupported = 0;
+            }
+          else if (datatype == 0)
+            nc5 = xmlNewNode (NULL, BAD_CAST "Format");
+          tmp1 = _tmp->content;
+          int oI = 0;
+          for (oI = 0; oI < 6; oI++)
+            if ((tmp1 = getMap (_tmp->content, orderedFields[oI])) != NULL)
+              {
 #ifdef DEBUG
-	  printf("DATATYPE SUPPORTED ? %s\n",tmp1->name);
-#endif
-	  if(strcmp(tmp1->name,"asReference")!=0 && 
-	     strcmp(tmp1->name,"value")!=0 && 
-	     strcmp(tmp1->name,"DataType")!=0 &&
-	     strcasecmp(tmp1->name,"extension")!=0){
-	    if(datatype!=1){
-	      char *tmp2=zCapitalize1(tmp1->name);
-	      nc6 = xmlNewNode(NULL, BAD_CAST tmp2);
-	      free(tmp2);
-	    }
-	    else{
-	      char *tmp2=zCapitalize(tmp1->name);
-	      nc6 = xmlNewNode(ns_ows, BAD_CAST tmp2);
-	      free(tmp2);
-	    }
-	    if(datatype==2){
-	      char *tmpv,*tmps;
-	      tmps=strtok_r(tmp1->value,",",&tmpv);
-	      while(tmps){
-		xmlAddChild(nc6,xmlNewText(BAD_CAST tmps));
-		tmps=strtok_r(NULL,",",&tmpv);
-		if(tmps){
-		  char *tmp2=zCapitalize1(tmp1->name);
-		  nc6 = xmlNewNode(NULL, BAD_CAST tmp2);
-		  free(tmp2);
-		}
-	      }
-	    }
-	    else{
-	      xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
-	    }
-	    xmlAddChild(nc5,nc6);
-	  }
-	  tmp1=tmp1->next;
-	}
-      if(hasSupported<=0){
-	if(datatype==0){
-	  xmlAddChild(nc4,nc5);
-	  xmlAddChild(nc3,nc4);
-	}else{
-	  if(datatype!=1)
-	    xmlAddChild(nc3,nc5);
-	}
-	hasSupported=1;
-      }
-      else
-	if(datatype==0){
-	  xmlAddChild(nc4,nc5);
-	  xmlAddChild(nc3,nc4);
-	}
-	else
-	  if(datatype!=1)
-	    xmlAddChild(nc3,nc5);
-
-      _tmp=_tmp->next;
-    }
-
-    if(hasSupported==0){
-      if(datatype==0)
-	xmlFreeNode(nc4);
-      xmlFreeNode(nc5);
-    }
-
-    _tmp=e->defaults;
-    if(datatype==1 && hasUOM1==true){
-      xmlAddChild(nc4,nc5);
-      xmlAddChild(nc3,nc4);
-    }
-
-    if(in>0 && datatype==1 &&
-       getMap(_tmp->content,"AllowedValues")==NULL &&
-       getMap(_tmp->content,"range")==NULL &&
-       getMap(_tmp->content,"rangeMin")==NULL &&
-       getMap(_tmp->content,"rangeMax")==NULL &&
-       getMap(_tmp->content,"rangeClosure")==NULL ){
-      tmp1=getMap(_tmp->content,"dataType");
-      if(tmp1!=NULL)
-	if(strcasecmp(tmp1->value,"boolean")==0){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST "AllowedValues");
-	  nc7 = xmlNewNode(ns_ows, BAD_CAST "Value");
-	  xmlAddChild(nc7,xmlNewText(BAD_CAST "true"));
-	  xmlAddChild(nc6,nc7);
-	  nc7 = xmlNewNode(ns_ows, BAD_CAST "Value");
-	  xmlAddChild(nc7,xmlNewText(BAD_CAST "false"));
-	  xmlAddChild(nc6,nc7);
-	  xmlAddChild(nc3,nc6);
-	}
-      xmlAddChild(nc3,xmlNewNode(ns_ows, BAD_CAST "AnyValue"));
-    }
-    
-    if((tmp1=getMap(_tmp->content,"value"))!=NULL){
-      nc7 = xmlNewNode(NULL, BAD_CAST "DefaultValue");
-      xmlAddChild(nc7,xmlNewText(BAD_CAST tmp1->value));
-      xmlAddChild(nc3,nc7);
-    }
-    
-    xmlAddChild(nc2,nc3);
-    
-    xmlAddChild(nc1,nc2);
-    
-    e=e->next;
-  }
-}
-
-void printProcessResponse(maps* m,map* request, int pid,service* serv,const char* service,int status,maps* inputs,maps* outputs){
-  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  xmlNodePtr nr,n,nc,nc1=NULL,nc3;
+                printf ("DATATYPE SUPPORTED ? %s\n", tmp1->name);
+#endif
+                if (strcmp (tmp1->name, "asReference") != 0 &&
+                    strcmp (tmp1->name, "value") != 0 &&
+                    strcmp (tmp1->name, "DataType") != 0 &&
+                    strcasecmp (tmp1->name, "extension") != 0)
+                  {
+                    if (datatype != 1)
+                      {
+                        char *tmp2 = zCapitalize1 (tmp1->name);
+                        nc6 = xmlNewNode (NULL, BAD_CAST tmp2);
+                        free (tmp2);
+                      }
+                    else
+                      {
+                        char *tmp2 = zCapitalize (tmp1->name);
+                        nc6 = xmlNewNode (ns_ows, BAD_CAST tmp2);
+                        free (tmp2);
+                      }
+                    if (datatype == 2)
+                      {
+                        char *tmpv, *tmps;
+                        tmps = strtok_r (tmp1->value, ",", &tmpv);
+                        while (tmps)
+                          {
+                            xmlAddChild (nc6, xmlNewText (BAD_CAST tmps));
+                            tmps = strtok_r (NULL, ",", &tmpv);
+                            if (tmps)
+                              {
+                                char *tmp2 = zCapitalize1 (tmp1->name);
+                                nc6 = xmlNewNode (NULL, BAD_CAST tmp2);
+                                free (tmp2);
+                              }
+                          }
+                      }
+                    else
+                      {
+                        xmlAddChild (nc6, xmlNewText (BAD_CAST tmp1->value));
+                      }
+                    xmlAddChild (nc5, nc6);
+                  }
+                tmp1 = tmp1->next;
+              }
+          if (hasSupported <= 0)
+            {
+              if (datatype == 0)
+                {
+                  xmlAddChild (nc4, nc5);
+                  xmlAddChild (nc3, nc4);
+                }
+              else
+                {
+                  if (datatype != 1)
+                    xmlAddChild (nc3, nc5);
+                }
+              hasSupported = 1;
+            }
+          else if (datatype == 0)
+            {
+              xmlAddChild (nc4, nc5);
+              xmlAddChild (nc3, nc4);
+            }
+          else if (datatype != 1)
+            xmlAddChild (nc3, nc5);
+
+          _tmp = _tmp->next;
+        }
+
+      if (hasSupported == 0)
+        {
+          if (datatype == 0)
+            xmlFreeNode (nc4);
+          xmlFreeNode (nc5);
+        }
+
+      _tmp = e->defaults;
+      if (datatype == 1 && hasUOM1 == true)
+        {
+          xmlAddChild (nc4, nc5);
+          xmlAddChild (nc3, nc4);
+        }
+
+      if (in > 0 && datatype == 1 &&
+          getMap (_tmp->content, "AllowedValues") == NULL &&
+          getMap (_tmp->content, "range") == NULL &&
+          getMap (_tmp->content, "rangeMin") == NULL &&
+          getMap (_tmp->content, "rangeMax") == NULL &&
+          getMap (_tmp->content, "rangeClosure") == NULL)
+        {
+          tmp1 = getMap (_tmp->content, "dataType");
+          if (tmp1 != NULL)
+            if (strcasecmp (tmp1->value, "boolean") == 0)
+              {
+                nc6 = xmlNewNode (ns_ows, BAD_CAST "AllowedValues");
+                nc7 = xmlNewNode (ns_ows, BAD_CAST "Value");
+                xmlAddChild (nc7, xmlNewText (BAD_CAST "true"));
+                xmlAddChild (nc6, nc7);
+                nc7 = xmlNewNode (ns_ows, BAD_CAST "Value");
+                xmlAddChild (nc7, xmlNewText (BAD_CAST "false"));
+                xmlAddChild (nc6, nc7);
+                xmlAddChild (nc3, nc6);
+              }
+          xmlAddChild (nc3, xmlNewNode (ns_ows, BAD_CAST "AnyValue"));
+        }
+
+      if ((tmp1 = getMap (_tmp->content, "value")) != NULL)
+        {
+          nc7 = xmlNewNode (NULL, BAD_CAST "DefaultValue");
+          xmlAddChild (nc7, xmlNewText (BAD_CAST tmp1->value));
+          xmlAddChild (nc3, nc7);
+        }
+
+      xmlAddChild (nc2, nc3);
+
+      xmlAddChild (nc1, nc2);
+
+      e = e->next;
+    }
+}
+
+void
+printProcessResponse (maps * m, map * request, int pid, service * serv,
+                      const char *service, int status, maps * inputs,
+                      maps * outputs)
+{
+  xmlNsPtr ns, ns_ows, ns_xlink, ns_xsi;
+  xmlNodePtr nr, n, nc, nc1 = NULL, nc3;
   xmlDocPtr doc;
-  time_t time1;  
-  time(&time1);
-  nr=NULL;
+  time_t time1;
+  time (&time1);
+  nr = NULL;
   /**
    * Create the document and its temporary root.
    */
-  doc = xmlNewDoc(BAD_CAST "1.0");
-  int wpsId=zooXmlAddNs(NULL,"http://www.opengis.net/wps/1.0.0","wps");
-  ns=usedNs[wpsId];
-
-  n = xmlNewNode(ns, BAD_CAST "ExecuteResponse");
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  int owsId=zooXmlAddNs(n,"http://www.opengis.net/ows/1.1","ows");
-  ns_ows=usedNs[owsId];
-  int xlinkId=zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
-  ns_xlink=usedNs[xlinkId];
-  int xsiId=zooXmlAddNs(n,"http://www.w3.org/2001/XMLSchema-instance","xsi");
-  ns_xsi=usedNs[xsiId];
-  
-  xmlNewNsProp(n,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsExecute_response.xsd");
-  
-  xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
-  xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-  addLangAttr(n,m);
+  doc = xmlNewDoc (BAD_CAST "1.0");
+  int wpsId = zooXmlAddNs (NULL, "http://www.opengis.net/wps/1.0.0", "wps");
+  ns = usedNs[wpsId];
+
+  n = xmlNewNode (ns, BAD_CAST "ExecuteResponse");
+  xmlNewNs (n, BAD_CAST "http://www.opengis.net/wps/1.0.0", BAD_CAST "wps");
+  int owsId = zooXmlAddNs (n, "http://www.opengis.net/ows/1.1", "ows");
+  ns_ows = usedNs[owsId];
+  int xlinkId = zooXmlAddNs (n, "http://www.w3.org/1999/xlink", "xlink");
+  ns_xlink = usedNs[xlinkId];
+  int xsiId =
+    zooXmlAddNs (n, "http://www.w3.org/2001/XMLSchema-instance", "xsi");
+  ns_xsi = usedNs[xsiId];
+
+  xmlNewNsProp (n, ns_xsi, BAD_CAST "schemaLocation",
+                BAD_CAST
+                "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsExecute_response.xsd");
+
+  xmlNewProp (n, BAD_CAST "service", BAD_CAST "WPS");
+  xmlNewProp (n, BAD_CAST "version", BAD_CAST "1.0.0");
+  addLangAttr (n, m);
 
   char tmp[256];
   char url[1024];
   char stored_path[1024];
-  memset(tmp,0,256);
-  memset(url,0,1024);
-  memset(stored_path,0,1024);
-  maps* tmp_maps=getMaps(m,"main");
-  if(tmp_maps!=NULL){
-    map* tmpm1=getMap(tmp_maps->content,"serverAddress");
+  memset (tmp, 0, 256);
+  memset (url, 0, 1024);
+  memset (stored_path, 0, 1024);
+  maps *tmp_maps = getMaps (m, "main");
+  if (tmp_maps != NULL)
+    {
+      map *tmpm1 = getMap (tmp_maps->content, "serverAddress");
     /**
      * Check if the ZOO Service GetStatus is available in the local directory.
